import { defineComponent, ref, openBlock, createBlock, unref, mergeProps, withCtx, createVNode, createElementBlock, Fragment, renderList, normalizeClass, renderSlot, createCommentVNode, createTextVNode, toDisplayString } from 'vue';
import { ElForm, ElFormItem } from '../../form/index.mjs';
import { ElRow } from '../../row/index.mjs';
import { ElCol } from '../../col/index.mjs';
import { ElInput } from '../../input/index.mjs';
import { ElSwitch } from '../../switch/index.mjs';
import _DatePicker from '../../date-picker/index.mjs';
import _TimePicker from '../../time-picker/index.mjs';
import _Cascader from '../../cascader/index.mjs';
import _CascaderPanel from '../../cascader-panel/index.mjs';
import { ElCheckbox, ElCheckboxGroup, ElCheckboxButton } from '../../checkbox/index.mjs';
import { ElInputNumber } from '../../input-number/index.mjs';
import { ElRadio, ElRadioGroup, ElRadioButton } from '../../radio/index.mjs';
import '../../../hooks/index.mjs';
import { mgFormProps } from './mg-form.mjs';
import { useGetFormAttr, useGetColumns, useGetItemSpan, useVaildJustify, useActionIsRight, useGetFormItemAttr, useCheckComShow, useGetItemOriginCfg } from './use-mg-form.mjs';
import _export_sfc from '../../../_virtual/plugin-vue_export-helper.mjs';
import { useNamespace } from '../../../hooks/use-namespace/index.mjs';

const BACKUP_KEY = "__empty";
const __default__ = defineComponent({
  name: "MgForm"
});
const _sfc_main = /* @__PURE__ */ defineComponent({
  ...__default__,
  props: mgFormProps,
  setup(__props, { expose }) {
    const props = __props;
    const formRef = ref();
    const ns = useNamespace("form", ref("mg"));
    const formAttrs = useGetFormAttr();
    const columns = useGetColumns(props);
    expose({ formRef });
    return (_ctx, _cache) => {
      return openBlock(), createBlock(unref(ElForm), mergeProps({
        ref_key: "formRef",
        ref: formRef
      }, unref(formAttrs), {
        model: _ctx.modelData,
        class: [unref(ns).b()]
      }), {
        default: withCtx(() => [
          createVNode(unref(ElRow), { gutter: _ctx.gutter }, {
            default: withCtx(() => [
              (openBlock(true), createElementBlock(Fragment, null, renderList(unref(columns), (item, index) => {
                var _a;
                return openBlock(), createBlock(unref(ElCol), {
                  key: (_a = item.key) != null ? _a : index,
                  span: unref(useGetItemSpan)(unref(columns), item, index),
                  offset: item.offset,
                  class: normalizeClass([
                    unref(ns).m("col"),
                    unref(ns).is("right", unref(useVaildJustify)(item, "right") || unref(useActionIsRight)(item)),
                    unref(ns).is("center", unref(useVaildJustify)(item, "center"))
                  ])
                }, {
                  default: withCtx(() => [
                    createVNode(unref(ElFormItem), mergeProps(unref(useGetFormItemAttr)(item), {
                      label: item.label,
                      prop: item.prop
                    }), {
                      default: withCtx(() => {
                        var _a2, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q;
                        return [
                          unref(useCheckComShow)(item, "slot") ? renderSlot(_ctx.$slots, item.slotKey, mergeProps({
                            key: 0,
                            item
                          }, unref(useGetItemOriginCfg)(item))) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "input") ? (openBlock(), createBlock(unref(ElInput), mergeProps({
                            key: 1,
                            modelValue: _ctx.modelData[(_a2 = item.modelKey) != null ? _a2 : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "date-picker") ? (openBlock(), createBlock(unref(_DatePicker), mergeProps({
                            key: 2,
                            modelValue: _ctx.modelData[(_b = item.modelKey) != null ? _b : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "time-picker") ? (openBlock(), createBlock(unref(_TimePicker), mergeProps({
                            key: 3,
                            modelValue: _ctx.modelData[(_c = item.modelKey) != null ? _c : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "switch") ? (openBlock(), createBlock(unref(ElSwitch), mergeProps({
                            key: 4,
                            modelValue: _ctx.modelData[(_d = item.modelKey) != null ? _d : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "cascader") ? (openBlock(), createBlock(unref(_Cascader), mergeProps({
                            key: 5,
                            modelValue: _ctx.modelData[(_e = item.modelKey) != null ? _e : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item), {
                            options: (_f = item.options) != null ? _f : []
                          }), null, 16, ["modelValue", "onUpdate:modelValue", "options"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "cascader-panel") ? (openBlock(), createBlock(unref(_CascaderPanel), mergeProps({
                            key: 6,
                            modelValue: _ctx.modelData[(_g = item.modelKey) != null ? _g : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item), {
                            options: (_h = item.options) != null ? _h : []
                          }), null, 16, ["modelValue", "onUpdate:modelValue", "options"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "checkbox") ? (openBlock(), createBlock(unref(ElCheckbox), mergeProps({
                            key: 7,
                            modelValue: _ctx.modelData[(_i = item.modelKey) != null ? _i : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item), {
                            label: (_k = (_j = item.labelValue) != null ? _j : item.label) != null ? _k : ""
                          }), {
                            default: withCtx(() => {
                              var _a3, _b2;
                              return [
                                createTextVNode(toDisplayString((_b2 = (_a3 = item.labelName) != null ? _a3 : item.label) != null ? _b2 : ""), 1)
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue", "label"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "checkbox-group") ? (openBlock(), createBlock(unref(ElCheckboxGroup), mergeProps({
                            key: 8,
                            modelValue: _ctx.modelData[(_l = item.modelKey) != null ? _l : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), {
                            default: withCtx(() => {
                              var _a3;
                              return [
                                (openBlock(true), createElementBlock(Fragment, null, renderList((_a3 = item.options) != null ? _a3 : [], (subItem, subIndex) => {
                                  var _a4, _b2, _c2, _d2;
                                  return openBlock(), createElementBlock(Fragment, {
                                    key: (_b2 = subItem[(_a4 = subItem == null ? void 0 : subItem.key) != null ? _a4 : unref(BACKUP_KEY)]) != null ? _b2 : subIndex
                                  }, [
                                    subItem.itemType === "checkbox-button" ? (openBlock(), createBlock(unref(ElCheckboxButton), mergeProps({ key: 0 }, subItem, {
                                      label: (_c2 = subItem.labelValue) != null ? _c2 : ""
                                    }), {
                                      default: withCtx(() => {
                                        var _a5;
                                        return [
                                          createTextVNode(toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"])) : (openBlock(), createBlock(unref(ElCheckbox), mergeProps({ key: 1 }, subItem, {
                                      label: (_d2 = subItem.labelValue) != null ? _d2 : ""
                                    }), {
                                      default: withCtx(() => {
                                        var _a5;
                                        return [
                                          createTextVNode(toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"]))
                                  ], 64);
                                }), 128))
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "input-number") ? (openBlock(), createBlock(unref(ElInputNumber), mergeProps({
                            key: 9,
                            modelValue: _ctx.modelData[(_m = item.modelKey) != null ? _m : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "radio") ? (openBlock(), createBlock(unref(ElRadio), mergeProps({
                            key: 10,
                            modelValue: _ctx.modelData[(_n = item.modelKey) != null ? _n : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item), {
                            label: (_p = (_o = item.labelValue) != null ? _o : item.label) != null ? _p : ""
                          }), {
                            default: withCtx(() => {
                              var _a3, _b2;
                              return [
                                createTextVNode(toDisplayString((_b2 = (_a3 = item.labelName) != null ? _a3 : item.label) != null ? _b2 : ""), 1)
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue", "label"])) : createCommentVNode("v-if", true),
                          unref(useCheckComShow)(item, "radio-group") ? (openBlock(), createBlock(unref(ElRadioGroup), mergeProps({
                            key: 11,
                            modelValue: _ctx.modelData[(_q = item.modelKey) != null ? _q : unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : unref(BACKUP_KEY)] = $event;
                            }
                          }, unref(useGetItemOriginCfg)(item)), {
                            default: withCtx(() => {
                              var _a3;
                              return [
                                (openBlock(true), createElementBlock(Fragment, null, renderList((_a3 = item.options) != null ? _a3 : [], (subItem, subIndex) => {
                                  var _a4, _b2, _c2, _d2;
                                  return openBlock(), createElementBlock(Fragment, {
                                    key: (_b2 = subItem[(_a4 = subItem == null ? void 0 : subItem.key) != null ? _a4 : unref(BACKUP_KEY)]) != null ? _b2 : subIndex
                                  }, [
                                    subItem.itemType === "radio-button" ? (openBlock(), createBlock(unref(ElRadioButton), mergeProps({ key: 0 }, subItem, {
                                      label: (_c2 = subItem.labelValue) != null ? _c2 : ""
                                    }), {
                                      default: withCtx(() => {
                                        var _a5;
                                        return [
                                          createTextVNode(toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"])) : (openBlock(), createBlock(unref(ElRadio), mergeProps({ key: 1 }, subItem, {
                                      label: (_d2 = subItem.labelValue) != null ? _d2 : ""
                                    }), {
                                      default: withCtx(() => {
                                        var _a5;
                                        return [
                                          createTextVNode(toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"]))
                                  ], 64);
                                }), 128))
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue"])) : createCommentVNode("v-if", true),
                          createCommentVNode(` <el-select
            v-if="useCheckComShow(item, 'select')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
          >
            <el-option
              v-for="(subItem, subIndex) in item.options ?? []"
              v-bind="subItem"
              :key="subItem[subItem?.key ?? BACKUP_KEY] ?? subIndex"
              :value="subItem.value ?? ''"
              :label="subItem.label ?? subItem.value ?? ''"
            />
          </el-select>
          <el-select-v2
            v-if="useCheckComShow(item, 'select-v2')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
            :options="((item.options ?? []) as Array<any>)"
          />
          <el-time-select
            v-if="useCheckComShow(item, 'time-select')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
          />
          <el-color-picker
            v-if="useCheckComShow(item, 'color-picker')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
          /> `)
                        ];
                      }),
                      _: 2
                    }, 1040, ["label", "prop"])
                  ]),
                  _: 2
                }, 1032, ["span", "offset", "class"]);
              }), 128))
            ]),
            _: 3
          }, 8, ["gutter"])
        ]),
        _: 3
      }, 16, ["model", "class"]);
    };
  }
});
var _MgForm = /* @__PURE__ */ _export_sfc(_sfc_main, [["__file", "/Users/jiajingshuai/mine/code/bty/\u7EC4\u4EF6\u5E93/bty-element/packages/components/mg-form/src/mg-form.vue"]]);

export { _MgForm as default };
//# sourceMappingURL=mg-form2.mjs.map
