'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var index$1 = require('../../form/index.js');
var index$2 = require('../../row/index.js');
var index$3 = require('../../col/index.js');
var index$4 = require('../../input/index.js');
var index$7 = require('../../switch/index.js');
var index$5 = require('../../date-picker/index.js');
var index$6 = require('../../time-picker/index.js');
var index$8 = require('../../cascader/index.js');
var index$9 = require('../../cascader-panel/index.js');
var index$a = require('../../checkbox/index.js');
var index$b = require('../../input-number/index.js');
var index$c = require('../../radio/index.js');
require('../../../hooks/index.js');
var mgForm = require('./mg-form.js');
var useMgForm = require('./use-mg-form.js');
var pluginVue_exportHelper = require('../../../_virtual/plugin-vue_export-helper.js');
var index = require('../../../hooks/use-namespace/index.js');

const BACKUP_KEY = "__empty";
const __default__ = vue.defineComponent({
  name: "MgForm"
});
const _sfc_main = /* @__PURE__ */ vue.defineComponent({
  ...__default__,
  props: mgForm.mgFormProps,
  setup(__props, { expose }) {
    const props = __props;
    const formRef = vue.ref();
    const ns = index.useNamespace("form", vue.ref("mg"));
    const formAttrs = useMgForm.useGetFormAttr();
    const columns = useMgForm.useGetColumns(props);
    expose({ formRef });
    return (_ctx, _cache) => {
      return vue.openBlock(), vue.createBlock(vue.unref(index$1.ElForm), vue.mergeProps({
        ref_key: "formRef",
        ref: formRef
      }, vue.unref(formAttrs), {
        model: _ctx.modelData,
        class: [vue.unref(ns).b()]
      }), {
        default: vue.withCtx(() => [
          vue.createVNode(vue.unref(index$2.ElRow), { gutter: _ctx.gutter }, {
            default: vue.withCtx(() => [
              (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList(vue.unref(columns), (item, index) => {
                var _a;
                return vue.openBlock(), vue.createBlock(vue.unref(index$3.ElCol), {
                  key: (_a = item.key) != null ? _a : index,
                  span: vue.unref(useMgForm.useGetItemSpan)(vue.unref(columns), item, index),
                  offset: item.offset,
                  class: vue.normalizeClass([
                    vue.unref(ns).m("col"),
                    vue.unref(ns).is("right", vue.unref(useMgForm.useVaildJustify)(item, "right") || vue.unref(useMgForm.useActionIsRight)(item)),
                    vue.unref(ns).is("center", vue.unref(useMgForm.useVaildJustify)(item, "center"))
                  ])
                }, {
                  default: vue.withCtx(() => [
                    vue.createVNode(vue.unref(index$1.ElFormItem), vue.mergeProps(vue.unref(useMgForm.useGetFormItemAttr)(item), {
                      label: item.label,
                      prop: item.prop
                    }), {
                      default: vue.withCtx(() => {
                        var _a2, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q;
                        return [
                          vue.unref(useMgForm.useCheckComShow)(item, "slot") ? vue.renderSlot(_ctx.$slots, item.slotKey, vue.mergeProps({
                            key: 0,
                            item
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item))) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "input") ? (vue.openBlock(), vue.createBlock(vue.unref(index$4.ElInput), vue.mergeProps({
                            key: 1,
                            modelValue: _ctx.modelData[(_a2 = item.modelKey) != null ? _a2 : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "date-picker") ? (vue.openBlock(), vue.createBlock(vue.unref(index$5["default"]), vue.mergeProps({
                            key: 2,
                            modelValue: _ctx.modelData[(_b = item.modelKey) != null ? _b : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "time-picker") ? (vue.openBlock(), vue.createBlock(vue.unref(index$6["default"]), vue.mergeProps({
                            key: 3,
                            modelValue: _ctx.modelData[(_c = item.modelKey) != null ? _c : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "switch") ? (vue.openBlock(), vue.createBlock(vue.unref(index$7.ElSwitch), vue.mergeProps({
                            key: 4,
                            modelValue: _ctx.modelData[(_d = item.modelKey) != null ? _d : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "cascader") ? (vue.openBlock(), vue.createBlock(vue.unref(index$8["default"]), vue.mergeProps({
                            key: 5,
                            modelValue: _ctx.modelData[(_e = item.modelKey) != null ? _e : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item), {
                            options: (_f = item.options) != null ? _f : []
                          }), null, 16, ["modelValue", "onUpdate:modelValue", "options"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "cascader-panel") ? (vue.openBlock(), vue.createBlock(vue.unref(index$9["default"]), vue.mergeProps({
                            key: 6,
                            modelValue: _ctx.modelData[(_g = item.modelKey) != null ? _g : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item), {
                            options: (_h = item.options) != null ? _h : []
                          }), null, 16, ["modelValue", "onUpdate:modelValue", "options"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "checkbox") ? (vue.openBlock(), vue.createBlock(vue.unref(index$a.ElCheckbox), vue.mergeProps({
                            key: 7,
                            modelValue: _ctx.modelData[(_i = item.modelKey) != null ? _i : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item), {
                            label: (_k = (_j = item.labelValue) != null ? _j : item.label) != null ? _k : ""
                          }), {
                            default: vue.withCtx(() => {
                              var _a3, _b2;
                              return [
                                vue.createTextVNode(vue.toDisplayString((_b2 = (_a3 = item.labelName) != null ? _a3 : item.label) != null ? _b2 : ""), 1)
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue", "label"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "checkbox-group") ? (vue.openBlock(), vue.createBlock(vue.unref(index$a.ElCheckboxGroup), vue.mergeProps({
                            key: 8,
                            modelValue: _ctx.modelData[(_l = item.modelKey) != null ? _l : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), {
                            default: vue.withCtx(() => {
                              var _a3;
                              return [
                                (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList((_a3 = item.options) != null ? _a3 : [], (subItem, subIndex) => {
                                  var _a4, _b2, _c2, _d2;
                                  return vue.openBlock(), vue.createElementBlock(vue.Fragment, {
                                    key: (_b2 = subItem[(_a4 = subItem == null ? void 0 : subItem.key) != null ? _a4 : vue.unref(BACKUP_KEY)]) != null ? _b2 : subIndex
                                  }, [
                                    subItem.itemType === "checkbox-button" ? (vue.openBlock(), vue.createBlock(vue.unref(index$a.ElCheckboxButton), vue.mergeProps({ key: 0 }, subItem, {
                                      label: (_c2 = subItem.labelValue) != null ? _c2 : ""
                                    }), {
                                      default: vue.withCtx(() => {
                                        var _a5;
                                        return [
                                          vue.createTextVNode(vue.toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"])) : (vue.openBlock(), vue.createBlock(vue.unref(index$a.ElCheckbox), vue.mergeProps({ key: 1 }, subItem, {
                                      label: (_d2 = subItem.labelValue) != null ? _d2 : ""
                                    }), {
                                      default: vue.withCtx(() => {
                                        var _a5;
                                        return [
                                          vue.createTextVNode(vue.toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"]))
                                  ], 64);
                                }), 128))
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "input-number") ? (vue.openBlock(), vue.createBlock(vue.unref(index$b.ElInputNumber), vue.mergeProps({
                            key: 9,
                            modelValue: _ctx.modelData[(_m = item.modelKey) != null ? _m : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), null, 16, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "radio") ? (vue.openBlock(), vue.createBlock(vue.unref(index$c.ElRadio), vue.mergeProps({
                            key: 10,
                            modelValue: _ctx.modelData[(_n = item.modelKey) != null ? _n : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item), {
                            label: (_p = (_o = item.labelValue) != null ? _o : item.label) != null ? _p : ""
                          }), {
                            default: vue.withCtx(() => {
                              var _a3, _b2;
                              return [
                                vue.createTextVNode(vue.toDisplayString((_b2 = (_a3 = item.labelName) != null ? _a3 : item.label) != null ? _b2 : ""), 1)
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue", "label"])) : vue.createCommentVNode("v-if", true),
                          vue.unref(useMgForm.useCheckComShow)(item, "radio-group") ? (vue.openBlock(), vue.createBlock(vue.unref(index$c.ElRadioGroup), vue.mergeProps({
                            key: 11,
                            modelValue: _ctx.modelData[(_q = item.modelKey) != null ? _q : vue.unref(BACKUP_KEY)],
                            "onUpdate:modelValue": ($event) => {
                              var _a3;
                              return _ctx.modelData[(_a3 = item.modelKey) != null ? _a3 : vue.unref(BACKUP_KEY)] = $event;
                            }
                          }, vue.unref(useMgForm.useGetItemOriginCfg)(item)), {
                            default: vue.withCtx(() => {
                              var _a3;
                              return [
                                (vue.openBlock(true), vue.createElementBlock(vue.Fragment, null, vue.renderList((_a3 = item.options) != null ? _a3 : [], (subItem, subIndex) => {
                                  var _a4, _b2, _c2, _d2;
                                  return vue.openBlock(), vue.createElementBlock(vue.Fragment, {
                                    key: (_b2 = subItem[(_a4 = subItem == null ? void 0 : subItem.key) != null ? _a4 : vue.unref(BACKUP_KEY)]) != null ? _b2 : subIndex
                                  }, [
                                    subItem.itemType === "radio-button" ? (vue.openBlock(), vue.createBlock(vue.unref(index$c.ElRadioButton), vue.mergeProps({ key: 0 }, subItem, {
                                      label: (_c2 = subItem.labelValue) != null ? _c2 : ""
                                    }), {
                                      default: vue.withCtx(() => {
                                        var _a5;
                                        return [
                                          vue.createTextVNode(vue.toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"])) : (vue.openBlock(), vue.createBlock(vue.unref(index$c.ElRadio), vue.mergeProps({ key: 1 }, subItem, {
                                      label: (_d2 = subItem.labelValue) != null ? _d2 : ""
                                    }), {
                                      default: vue.withCtx(() => {
                                        var _a5;
                                        return [
                                          vue.createTextVNode(vue.toDisplayString((_a5 = subItem.labelName) != null ? _a5 : ""), 1)
                                        ];
                                      }),
                                      _: 2
                                    }, 1040, ["label"]))
                                  ], 64);
                                }), 128))
                              ];
                            }),
                            _: 2
                          }, 1040, ["modelValue", "onUpdate:modelValue"])) : vue.createCommentVNode("v-if", true),
                          vue.createCommentVNode(` <el-select
            v-if="useCheckComShow(item, 'select')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
          >
            <el-option
              v-for="(subItem, subIndex) in item.options ?? []"
              v-bind="subItem"
              :key="subItem[subItem?.key ?? BACKUP_KEY] ?? subIndex"
              :value="subItem.value ?? ''"
              :label="subItem.label ?? subItem.value ?? ''"
            />
          </el-select>
          <el-select-v2
            v-if="useCheckComShow(item, 'select-v2')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
            :options="((item.options ?? []) as Array<any>)"
          />
          <el-time-select
            v-if="useCheckComShow(item, 'time-select')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
          />
          <el-color-picker
            v-if="useCheckComShow(item, 'color-picker')"
            v-model="modelData![item.modelKey ?? BACKUP_KEY]"
            v-bind="useGetItemOriginCfg(item)"
          /> `)
                        ];
                      }),
                      _: 2
                    }, 1040, ["label", "prop"])
                  ]),
                  _: 2
                }, 1032, ["span", "offset", "class"]);
              }), 128))
            ]),
            _: 3
          }, 8, ["gutter"])
        ]),
        _: 3
      }, 16, ["model", "class"]);
    };
  }
});
var _MgForm = /* @__PURE__ */ pluginVue_exportHelper["default"](_sfc_main, [["__file", "/Users/jiajingshuai/mine/code/bty/\u7EC4\u4EF6\u5E93/bty-element/packages/components/mg-form/src/mg-form.vue"]]);

exports["default"] = _MgForm;
//# sourceMappingURL=mg-form2.js.map
